/* -*- mode: c++; c-basic-offset: 4; -*- */
#include "chan_type.hh"
#include <stdexcept>
#include <cstring>

using namespace sends;
using namespace std;

//======================================  Conversion tables
static const char* type_strings[] = {
    "unknown",
    "online",
    "raw",
    "reduced", 
    "s-trend", 
    "m-trend",
    "test-pt",
    "static",
    "simdata",
    0
};

//======================================  String accessor
const char* 
chan_type::str(void) const {
    return type_strings[mChanType];
}

//======================================  Set based on a string
void
chan_type::set(const std::string& s) {
    for (int i=int(kUnknown); i<int(kTypeCount); i++) {
	if (s == type_strings[i]) {
	    mChanType = static_cast<chan_enum>(i);
	    return;
	}
    }
    throw runtime_error("Unrecognized channel type name");
}

//======================================  Set based on a string
void
chan_type::set(const char* s) {
    for (int i=int(kUnknown); i<int(kTypeCount); i++) {
	if (!strcmp(s, type_strings[i])) {
	    mChanType = static_cast<chan_enum>(i);
	    return;
	}
    }
    throw runtime_error("Unrecognized channel type name");
}
