#include <iostream>
#include <ctime>
#include "user_data.hh"
#include "user_update.hh"

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

using namespace sends;

user_list_update::user_list_update(const std::string& userfile_name):mUserFileName(userfile_name) {}

user_list_update::~user_list_update() {}

void *
user_list_update::thread_entry() {
	while (run()) {
		//std::cout << "user_list_update thread iteration" << std::endl;
	
		struct stat fInfo;
		if (stat(mUserFileName.c_str(), &fInfo) == 0) {
			if (fInfo.st_mtime > User_List.timestamp()) {
				// What is the best way to do this?
				std::cout << "Updating userfile list" << std::endl;
				user_list ul;
				ul.readFile(mUserFileName);
				User_List.swap(ul);
			}
		}

		mWaitGateway.lock();
		mWaitGateway.wait_timed(60.0);
		mWaitGateway.unlock();
	}
	return 0;
}